/*
    ViewTemplateCmd.h - template viewer

    Will Eighteen: will@opaline.demon.co.uk
*/

#ifndef VIEWTEMPLATECMD_H
#define VIEWTEMPLATECMD_H


#include <NoUndoCmd.h>
#include <GraphFltCmd.h>
#include <GraphIntCmd.h>


class DMenuCmd;

class ViewTemplateCmd : public NoUndoCmd
{
	protected:
		virtual void doCommand();	// ViewTemplate
		
	public:
		ViewTemplateCmd ( const char *, int active = TRUE );
		virtual const char *const className() { return ( "ViewTemplateCmd" ); }

	private:
		static void dMenuSelectionCallback ( void *, unsigned int, char * );
		static void viewTemplateIntCmdCallback ( void *, void *, long, long, long,
											long, long, long, Boolean, unsigned, unsigned );
		static void viewTemplateFltCmdCallback ( void *, void *, long, long, long,
											long, long, float, Boolean, unsigned, unsigned );
		void viewTemplate ( unsigned int );
		void viewTemplateCmdCallbackFinished ( GraphIntCmd *, GraphFltCmd *, long, long, long, long, long, long,
												float, Boolean, unsigned, unsigned );
		void createDataArray ( unsigned, long );

		long _currentSamples;
		unsigned _arrayItems;	// num items on menu
		Boolean _viewMenuRealised;
		DMenuCmd *_dMenu;
};

#endif

